<?
/**
* Class ActivityHelper
* for Activity class manipulation
*/
class ActivityHelper {
	
	/*
	* Get list of all project by manager
	*/
	function findAllActivity($user) {
		$result = array();
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return $result;
    		
		if ($user->isManager()) {
			$sel_str = "select a.a_id, a.a_name, a.a_project_id, p.p_id, p.p_name 
				from activities a, activity_status_list asl left join projects p on (a.a_project_id=p.p_id and p.p_status=1)
				where a.a_manager_id = ". $user->getUserId() ." and asl.asl_id = a.a_status and asl.asl_hidden = 0 order by a.a_name";
  		} else {
    		$sel_str = "select a.a_id, a.a_name, a.a_project_id, p.p_id, p.p_name 
    			from activities a, activity_status_list asl left join projects p on (a.a_project_id=p.p_id and p.p_status=1)
    			where a.a_manager_id = ". $user->getManagerId() ." and asl.asl_id = a.a_status and asl.asl_hidden = 0 order by a.a_name";
  		}

		$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		while ($val = $rc->fetchRow()) {
      			$result[] = $val;
      		}
      		$result = mu_sort($result,"a_name");
  		}
  		
  		return $result;
	}
	
	function findActivityById($user_id, $act_id) {
	  $db = DB::connect(DSN);
      if (DB::isError($db))
    		return false;
    		
	  $sth = $db->prepare("select a.a_id, a.a_name, asl.asl_name, a.a_project_id 
                from activities a, activity_status_list asl, users u
                where u.u_id=a.a_manager_id and u.u_id=$user_id and a.a_id = $act_id and asl.asl_id = a.a_status");
	  $db->setFetchMode(DB_FETCHMODE_ASSOC);
  	  $rc = $db->execute($sth);
	  if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
		    if ($val['a_id'] != '') {
      			return $val;
    		} else {
      			return false;
    		}
	  }
	  return false;
    }
    
    function findActivityByName($user_id, $act_name) {
      $db = DB::connect(DSN);
      if (DB::isError($db))
    		return false;
    		
	  $sth = $db->prepare("select a.a_id, a.a_name, asl.asl_name, a.a_project_id 
                from activities a, activity_status_list asl, users u
                where u.u_id=a.a_manager_id and u.u_id=$user_id and a.a_name = '$act_name' and asl.asl_id = a.a_status");
	  $db->setFetchMode(DB_FETCHMODE_ASSOC);
  	  $rc = $db->execute($sth);
	  if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
		    if ($val['a_id'] != '') {
      			return $val;
    		} else {
      			return false;
    		}
	  }
	  return false;
    }
	
	function isActivityExistsStrict($activity_id,$user) {
		$result = false;
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$user_id = $user->getManagerId();
    	if ($user->isManager()) $user_id = $user->getUserId();
    	
    	$sel_str = "select count(a.a_id) as actc
    			from activities a, activity_status_list asl
    			where a.a_id = $activity_id and a.a_manager_id=".$user_id." 
    			and a.a_status = asl.asl_id and asl.asl_hidden = 0";
    	$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		if ($val = $rc->fetchRow()) {
    			if ($val["actc"]>0) $result = true;
      		}
  		}
  		
  		return $result;
	}
	
	function isActivityExists($activity_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$sel_str = "select count(a.a_id) from activities a, activity_status_list asl where a.a_id = $activity_id and a.a_status = asl.asl_id and asl.asl_hidden = 0";
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();

    		if ($val[0] > 0) {
      			return true;
    		} else {
      			return false;
    		}
  		}
  		return false;
	}
	
	function getHiddenActivity() {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;

  		$sth = $db->prepare("select asl_id from activity_status_list where asl_hidden = 1");
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
    		if ($val[0]) {
      			return $val[0];
    		} else {
      			return false;
    		}
  		}
    	return false;
  	}
  	
  	function insert($user_id, $activity_name, $project_id) {
  		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		if (!isset($project_id) || $project_id=="") $project_id = 0;
  		$sth = $db->prepare("insert into activities (a_manager_id, a_name, a_project_id) values ($user_id, '!', $project_id)");
  		$data = array($activity_name);
  		$rc = $db->execute($sth, $data);
  		if (DB::isError($rc) == 0) {
    		return true;
  		}
		return false;
  	}
  	
  	function update($user_id, $activity_id, $activity_name, $project_id) {
  		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		if (!isset($project_id) || $project_id=="") $project_id = 0;
  		$hidden_act = ActivityHelper::getHiddenActivity();
  		if ($hidden_act) {
    		$sth = $db->prepare("update activities set a_name = '!',  a_project_id=$project_id where a_id = $activity_id and a_manager_id = $user_id and a_status <> $hidden_act");
    		$data = array($activity_name);
    		$rc = $db->execute($sth, $data);
    		if (DB::isError($rc) == 0) {
      			return true;
    		}
  		}
      	return false;
	}
	
	function delete($user_id, $activity_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;

  		$hidden_act = ActivityHelper::getHiddenActivity();
  		if ($hidden_act) {
    		$sth = $db->prepare("update activities set a_status = $hidden_act where a_id = $activity_id and a_manager_id = $user_id");
    		$rc = $db->execute($sth);
    		if (DB::isError($rc) == 0) {
      			return true;
    		}
	    }
    	return false;
	}

}
?>