<?php
class TimeHelper {
	
	function parseTimeString($crdate) {
		$i18n = &$GLOBALS["I18N"];
		$res = $i18n->getTimeString();
		$res = str_replace("%W",$i18n->getWeekDayName($crdate->getDay()),$res);
		$res = str_replace("%M",$i18n->getMonthName($crdate->getMonth()-1),$res);
		$res = str_replace("%D",$crdate->getDate(),$res);
		$res = str_replace("%Y",$crdate->getYear(),$res);
		return $res;
	}
	
	function isValidTime($value) {
		if (strlen($value)==0 || !isset($value)) return false;
	    if (preg_match("/^([0-1]{0,1}[0-9]|[2][0-3])$/", $value )) { // 0, 1 ... 9, 10, .. 22, 23
    	  	return true;
    	}
    	if (preg_match("/^([0-1]{0,1}[0-9]|[2][0-3])[:][0-5][0-9]$/", $value )) { // 0:59, 1:59, 01:59, 19:59, 23:59
      		return true;
    	}
      	return false;
	}
	
	function isValidDuration($value) {
		if (strlen($value)==0 || !isset($value)) return false;
	    if (preg_match("/^([0-9]{0,1}[0-9])$/", $value )) { // 0, 1 ... 9, 10, .. 99
    	  	return true;
    	}
    	if (preg_match("/^([0-9]{0,1}[0-9])[:][0-5][0-9]$/", $value )) { // 0:59, 1:59, 01:59, 19:59, 23:59
      		return true;
    	}
      	return false;
	}
	
	function normTimeString($value) {
		$time_a = split(":", $value);
		$time_a[1] = @$time_a[1] + 0;
		if (@$time_a[1] < 10 ) @$time_a[1] = "0$time_a[1]";
	  	return @$time_a[0].":".@$time_a[1];
	}
	
	function toMinutes($value) {
		$time_a = split(":", $value);
		return (int)@$time_a[1] + ((int)@$time_a[0]) * 60;
	}
	
	/**
	 * Check time interval
	 *
	 * @param unknown $start
	 * @param unknown $finish
	 * @return unknown
	 */
	function isCorrectTimeInterval($start, $finish) {
  		$pair1 = split(":", $start);
  		$pair2 = split(":", $finish);
  		$val1 = (int)@$pair1[0] * 60 + (int)@$pair1[1];
  		$val2 = (int)@$pair2[0] * 60 + (int)@$pair2[1];
  		if ($val1 >= $val2) {
    		return false;
  		} else {
    		return true;
  		}
	}
	
	function update($date, $ts, $user_id, $project, $activity, $start, $finish, $duration, $note) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$sf_flag = (($start) && ($finish));
	    $start = TimeHelper::normTimeString($start);
   		$finish = TimeHelper::normTimeString($finish);
   		$duration = TimeHelper::normTimeString($duration);
   		$note = str_replace("!","\!",$note);
  		$note = str_replace("?","\?",$note);
  		$note = str_replace("&","\&",$note);
  		$note = str_replace("'","\'",$note);
  
	    if ($sf_flag) {
		  $time_duration_min = TimeHelper::toMinutes($finish) - TimeHelper::toMinutes($start);
	      if ($time_duration_min <= 0) {
	        return false;
	      }
	      $time_duration[0] = $time_duration_min / 60;
	      $some = split("[.,]", $time_duration[0]);
	      $time_duration[0] = $some[0];
	      $time_duration[1] = $time_duration_min - (int)$time_duration[0] * 60;
	      if ($time_duration[1] < 10 ) {
	        $time_duration[1] = "0$time_duration[1]";
	      }
	      $duration = "$time_duration[0]:$time_duration[1]";
	      $upd_str = "update activity_log set al_from = '$start', al_duration = '$duration', al_project_id = $project, al_activity_id = $activity, al_comment = '!' where al_date = '$date' and al_user_id = $user_id and al_timestamp = '$ts'";
	      $data = array($note);
	    } elseif ($duration) {
	      $upd_str = "update activity_log set al_from = NULL, al_duration = '$duration', al_project_id = $project, al_activity_id = $activity, al_comment = '!' where al_date = '$date' and al_user_id = $user_id and al_timestamp = '$ts'";
	      $data = array($note);
	    } else {
	      return false;
	    }

    	$sth = $db->prepare($upd_str);
    	$rc = $db->execute($sth,$data);
    	if (DB::isError($rc) == 0) {
      		return true;
    	}
    	return false;
	}
	
	function insert($date, $user_id, $project, $activity, $start, $finish, $duration, $note) {
	  	$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$sf_flag = ((isset($start)) && (isset($finish)));
   		$start = TimeHelper::normTimeString($start);
   		$finish = TimeHelper::normTimeString($finish);
   		$duration = TimeHelper::normTimeString($duration);
    	$note = str_replace("!","\!",$note);
  		$note = str_replace("?","\?",$note);
  		$note = str_replace("&","\&",$note);
  		$note = str_replace("'","\'",$note);
    		
  	  	if ($sf_flag) {
		    $time_duration_min = TimeHelper::toMinutes($finish) - TimeHelper::toMinutes($start);
		    if ($time_duration_min <= 0) {
		      return false;
		    }
		    $time_duration[0] = $time_duration_min / 60;
		    $some = split("[.,]", $time_duration[0]);
		    $time_duration[0] = $some[0];
		    $time_duration[1] = $time_duration_min - (int)$time_duration[0] * 60;
		    if ($time_duration[1] < 10 ) {
		      $time_duration[1] = "0$time_duration[1]";
		    }
		    $duration = "$time_duration[0]:$time_duration[1]";
		    $ins_str = "insert into activity_log(al_user_id, al_date, al_from, al_duration, al_project_id, al_activity_id, al_comment) values ($user_id, '$date', '$start', '$duration', $project, $activity, '!')";
		    $data = array($note);
	  	} elseif ($duration) {
		    $ins_str = "insert into activity_log(al_user_id, al_date, al_duration, al_project_id, al_activity_id, al_comment) values ($user_id, '$date', '$duration', $project, $activity, '!')";
		    $data = array($note);
	  	} else {
    		return false;
  	  	}

  	  	$sth = $db->prepare($ins_str);
  	  	$rc = $db->execute($sth, $data);
  	  	if (DB::isError($rc) == 0) {
	    	return true;
  		}
  		return false;
	}
	
	function delete($user_id, $ts, $date) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$upd_str = "delete from activity_log where al_date = '$date' and al_user_id = $user_id and al_timestamp = '$ts'";	
  		$sth = $db->prepare($upd_str);
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		return true;
  		}
	    return false;
	}
	
	function getTotalTime($date, $user_id) {
		$result = "0:00";
  		
  		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$sth = $db->prepare("select TIME_FORMAT(sec_to_time(sum(time_to_sec(al_duration))), '%k:%i') from activity_log where al_user_id = $user_id and al_date = '$date'");
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
    		return $val[0];
  		}
  		return false;
	}
	
	function findAllTime($date, $user_id) {
  		$result = array();
  		
  		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
  
  		$sel_str = "select TIME_FORMAT(al.al_from, '%k:%i') as tfrom, 
  									TIME_FORMAT(sec_to_time(time_to_sec(al.al_from) + time_to_sec(al.al_duration)), '%k:%i') as tto,
  									TIME_FORMAT(al.al_duration, '%k:%i') as tdur, p.p_name, a.a_name, al_comment, al_timestamp
  								from activity_log al, projects p, activities a
  								where al.al_date = '$date' and al.al_user_id = $user_id and p.p_id = al.al_project_id and a.a_id = al.al_activity_id
  								order by al.al_from, al.al_duration";
  		$sth = $db->prepare($sel_str);
		$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$rc = $db->execute($sth);
    	if (DB::isError($rc) == 0) {
    		while ($val = $rc->fetchRow()) {
      			$val['tfrom'] = (!$val['tfrom'] ? '&nbsp;' : htmlspecialchars($val['tfrom']));
      			$val['tto'] = (!$val['tto'] ? '&nbsp;' : htmlspecialchars($val['tto']));
      			$val['al_comment'] = (!$val['al_comment'] ? '&nbsp;' : htmlspecialchars($val['al_comment']));
      			$result[] = $val;
      		}
  		} else return false;

		return $result;
	}
	
	function findTimeByUserAndDate($user_id, $ts, $date) {
  		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
	  	$sel_str = "select TIME_FORMAT(al.al_from, '%k:%i') as tfrom,
	  		TIME_FORMAT(sec_to_time(time_to_sec(al.al_from) + time_to_sec(al.al_duration)),'%k:%i') as tto,
	  		TIME_FORMAT(al.al_duration, '%k:%i') as tdur,
	  		p.p_name, a.a_name, al.al_comment, al.al_project_id, al.al_activity_id
	  		from activity_log al, projects p, activities a
	  		where al.al_date = '$date' and al.al_user_id = $user_id and al.al_timestamp = '$ts' and p.p_id = al.al_project_id and a.a_id = al.al_activity_id
	  		order by al.al_from";
	  	$sth = $db->prepare($sel_str);
	  	$db->setFetchMode(DB_FETCHMODE_ASSOC);
	  	$rc = $db->execute($sth);
	  	if (DB::isError($rc) == 0) {
	    	if (!$rc->numRows()) {
	      		return false;
	    	}
		    if ($val = $rc->fetchRow()) {
		    	return $val;
		    }
	  	}
	  	return false;
	}


}
?>