<?
/**
 *       
 *
 */
class DateTime {
	var $mHour = 0;
	var $mMinute = 0;
	var $mSecond = 0;
	var $mMonth;
	var $mDay;		// day of week
	var $mDate;		// day of month
	var $mYear;
	var $mIntrFormat	= "d.m.Y H:i:s"; //29.02.2004 16:21:42 internal format date
	var $mLocalFormat;
	var $mParseResult = 0;
	var $mAutoComplete = true;
	
	/**
	 * 
	 *
	 * @param String $format
	 * @param String $strfDateTime
	 * @return DateTime
	 */
	function DateTime($format="",$strfDateTime="") {
		$this->mLocalFormat = ($format ? $format : $this->mIntrFormat);
		$d = ($strfDateTime ? $strfDateTime : date($this->mLocalFormat));
		$this->parseVal($d);
	}
	
	function setFormat($format) {
		$this->mLocalFormat = $format;
	}
	
	function getFormat() {
		return $this->mLocalFormat;
	}
	
	function getDate() { return $this->mDate; }
	function getDay() { return $this->mDay; }
	function getMonth() { return $this->mMonth; }
	function getYear() { return $this->mYear; }
	
	function setDate($value) { $this->mDate = $value; }
	function setMonth($value) { $this->mMonth = $value; }
	function setYear($value) { $this->mYear = $value; }
	
	function setTimestamp($ts) {
		$this->mDate = date("d",$ts);
		$this->mDay = date("w",$ts);
		$this->mMonth = date("m",$ts);
      	$this->mYear = date("Y",$ts);
       	$this->mHour = date("H",$ts);
        $this->mMinute = date("i",$ts);
		$this->mSecond = date("s",$ts);
	}
	
	/**
	 * Return UNIX timestamp
	 */
	function getTimestamp() {
		return @mktime($this->mHour, $this->mMinute, $this->mSecond, $this->mMonth, $this->mDate, $this->mYear);
	}
	
	function compare($datetime) {
		$ts1 = $this->getTimestamp();
		$ts2 = $datetime->getTimestamp();
		if ($ts1<$ts2) return -1;
		if ($ts1==$ts2) return 0;
		if ($ts1>$ts2) return 1;
	}
	
	function toString($format="") {
		if ($this->mParseResult==0) {
			if ($format) {
				return date($format,$this->getTimestamp());
			} else {
				return date($this->mLocalFormat,$this->getTimestamp());
			}
		} else {
			if ($format) {
				return date($format,$this->mLocalFormat);
			} else {
				return date($this->mLocalFormat);
			}
		}
	}
	
    function parseVal($szDate, $format="") {
    	$useformat = ($format ? $format : $this->mLocalFormat);
     	$dateComp = preg_split('%[- /.:]%', $szDate);
        $formatComp = preg_split('%[- /.:]%', $useformat);
        if (is_array($dateComp) && is_array($formatComp)) {
        	foreach ($formatComp as $k=>$comp) {
        		switch ($comp) {
        			case "d":
        			  $this->mDate = @$dateComp[$k];
        			break;
        			case "m":
        			  $this->mMonth = @$dateComp[$k];
        			break;
        			case "Y":
        			  $this->mYear = @$dateComp[$k];
        			break;
        			case "H":
        			  $this->mHour = @$dateComp[$k];
        			break;
        			case "i":
        			  $this->mMinute = @$dateComp[$k];
        			break;
        			case "s":
        			  $this->mSecond = @$dateComp[$k];
        			break;
        		}
        	}
        	if ($this->mAutoComplete && !isset($this->mYear)) $this->mYear = date("Y");
        	if (!@checkdate($this->mMonth, $this->mDate, $this->mYear)) {
        		$this->mParseResult = 1;
        	}
        	if ($this->mParseResult==0) $this->mDay = date("w",$this->getTimestamp());
        } else {
        	$this->mParseResult = 2;
        }
        if ($this->mParseResult!=0 && $this->mAutoComplete) {
        	$this->setTimestamp(time());
        }
        return $this->mParseResult;
    }
    
    function isError() {
    	if ($this->mParseResult!=0) return true;
    	return false;
    }
}
?>