<?php
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 2000, 2002 Windmill Studio                             |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the PHP license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Igor Melnik <igor@rivne.com>                                |
// +----------------------------------------------------------------------+
//
// $Id: HttpRequest.class.php,v 1.3 2005/08/29 17:05:30 imelnik Exp $

//
//      
//

class HttpRequest {
   	var $_params = array();
   	var $parsed_uri = 0;

	function HttpRequest() {
		$this->_parseUri();
	}
	
	/**
	 * @return unknown
	 * @desc    (Get, Post)
     */
	function getMethod() {
		return isset( $GLOBALS['HTTP_SERVER_VARS']['REQUEST_METHOD'] ) ? $GLOBALS['HTTP_SERVER_VARS']['REQUEST_METHOD'] : false;
	}
	
	/**
	 * @return unknown
	 * @param objName = "" unknown
	 * @param default = "" unknown
	 * @desc   
     */
	function getParameter($objName="", $default=null) { 
		switch ( $this->getMethod() )
        {
            case 'GET':
            	if (isset($GLOBALS['HTTP_GET_VARS'][$objName])
            	   && ($GLOBALS['HTTP_GET_VARS'][$objName]!=""))
            	   return $GLOBALS['HTTP_GET_VARS'][$objName];

            case 'POST':
            	if (isset($GLOBALS['HTTP_POST_VARS'][$objName])
            	   && ($GLOBALS['HTTP_POST_VARS'][$objName]!=""))
            	   return  $GLOBALS['HTTP_POST_VARS'][$objName];
        }
        
        if (isset($this->_params[$objName]))
            return $this->_params[$objName];
            
        return $default;
	}
	
	function getAttribute($objName) {
		return $this->getParameter($objName);
	}
	
	function getCookieAttribute($objName="") {
	    if ($objName) {
   	        return $GLOBALS['HTTP_COOKIE_VARS'][$objName];
   	    }
    	return null;
    }

    
   	function getSessionAttribute($objName="") {
   	    if ($objName) {
   	        return $GLOBALS['HTTP_SESSION_VARS'][$objName];
   	    }
    	return null;
    }
    
	/**
	 * @return void
	 * @desc            POST
	 */
	function _parseUri()	{
		global $HTTP_SERVER_VARS;
		
		if ($this->parsed_uri==0) {
	    	$pairs = preg_split('/[&;]/', $HTTP_SERVER_VARS["QUERY_STRING"]);
	
	    	foreach( $pairs as $_ )	{
	    		if (is_array($_)) {
		      		list($k,$v) = explode('=', $_);
			        $param = urldecode($k);
		      		$value = urldecode($v);
		      		$value = isset($value) ? $value : '';
		      		$this->_params[ $param ] = $value;
	    		}
	    	}
	    	$this->parsed_uri = 1;
		}
  	}
  	
  	function getScriptName() {
  		$script_name = $GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'];
  		$pos = strpos($script_name,"?");
  		if (!($pos === false)) {
  			$script_name = substr($script_name,1,$pos-1);
  		}
  		if ($script_name[0]!="/") $script_name = "/".$script_name;
  	    return $script_name;
  	    //['SCRIPT_NAME'];
  	}
  	
  	function getRequestUri() {
  	    return $GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'];
  	}
  	
  	function getLastHint() {
  	    return $GLOBALS['HTTP_SESSION_VARS']['LAST_HINT'];
  	}

}
?>