<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('UserHelper');
	
	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}
	
	$ud = UserHelper::findUserById($user->getUserId(),$user);
	if ($request->getMethod()=="POST") {
		$cl_name  = $request->getParameter('name');
		$cl_name  = trim($cl_name);
		$cl_email  = $request->getParameter('email');
		$cl_email	= trim(strtolower($cl_email));
		$cl_password1	= $request->getParameter('pas1');
  		$cl_password2	= $request->getParameter('pas2');
  		$cl_company	= $request->getParameter('comp');
  		$cl_www		= $request->getParameter('www');
  		$cl_currency = $request->getParameter('curr');
  		if (!$cl_currency) $cl_currency = 'US$';
	} else {
        $cl_name	= $ud["u_name"];
        $cl_email	= $ud["u_login"];
        $cl_password1 = $cl_password2 = $ud["u_password"];
        $cl_company = $ud["c_name"];
        $cl_www = $ud["c_www"];
        $cl_currency = ( $ud["c_currency"]=="" ? "US$" : $ud["c_currency"]);
	}
	
	$form = new Form('profileForm');
	$form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"name","value"=>$cl_name));
    $form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"email","value"=>$cl_email,"enable"=>false));
    $form->addInput(array("type"=>"text","maxlength"=>"30","name"=>"pas1","aspassword"=>true,"value"=>$cl_password1));
    $form->addInput(array("type"=>"text","maxlength"=>"30","name"=>"pas2","aspassword"=>true,"value"=>$cl_password2));
    $form->addInput(array("type"=>"text","maxlength"=>"200","name"=>"comp","value"=>$cl_company));
    $form->addInput(array("type"=>"text","maxlength"=>"250","name"=>"www","value"=>$cl_www));
    $form->addInput(array("type"=>"text","maxlength"=>"10","name"=>"curr","value"=>$cl_currency));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit","value"=>$i18n->getKey('button.save')));
	
	if ($request->getMethod()=="POST") {
		import('form.check.Validator');
		
		$validator = new Validator($cl_name);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		if (!$validator->isValid()) {
			$errors->add("name",$i18n->getKey("errors.wrong"),$i18n->getKey("form.profile.name"));	
		}
		
		$validator = new Validator($cl_email);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		$validator->validateLatinCharset();
		if (!$validator->isValid()) {
	    	$errors->add("email",$i18n->getKey("errors.wrong"),$i18n->getKey("form.profile.email"));
	    }
	    
	    $validator = new Validator($cl_password1);
		$validator->validateSpaceString();
		//$validator->validateEmptyString();
		//$validator->validateLatinCharset();
    	if (!$validator->isValid()) {
    		$errors->add("password",$i18n->getKey("errors.wrong"),$i18n->getKey("form.profile.pas1"));
    	} elseif (!($cl_password1 === $cl_password2))
    		$errors->add("passwords",$i18n->getKey("errors.compare"),$i18n->getKey("form.profile.pas1"),$i18n->getKey("form.profile.pas2"));
    
		if ($errors->isEmpty())
		if (UserHelper::findUserByLogin($cl_email)) {
			if (UserHelper::updateAccount($user, $cl_name, $cl_email, $cl_password1, $cl_company, $cl_www, $cl_currency)) {
				$user->setUserId($user->getUserId()); // reload personal data
				Header("Location: mytime.php");
				exit();
			} else {
				$errors->add("newprofile",$i18n->getKey("errors.prof_error"));
			}
		} else 
			$errors->add("newprofile",$i18n->getKey("errors.no_user"));
	} // post
	
	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
	$smarty->assign("forms",array($form->getName()=>$form->toArray()));
    $smarty->assign("onload","onLoad = \"document.profileForm.name.focus()\"");
    $smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("title_page",$i18n->getKey("form.profile.prof_str"));
  	if ($ud) {
    	$smarty->assign("content_page_name","profile_edit.tpl");
    } else {
    	$smarty->assign("content_page_name","syserror.tpl");
    }
  	$smarty->display(INDEX_TEMPLATE);
?>