<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+
// | Contributors: Igor Melnik <igor@rivne.com>
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('form.ActionForm');
	import('form.check.Validator');
	import('DateTime');
	import('Period');
	import('ProjectHelper');
    import('ActivityHelper');
    import('UserHelper');
    import('InvoiceHelper');
    
	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}

	$form = new Form("invoiceForm");
    $form->addInput(array("type"=>"datefield","name"=>"date","size"=>"20"));
    $form->addInput(array("type"=>"text","name"=>"number","size"=>"20"));
    $form->addInput(array("type"=>"textarea","name"=>"yourcoo","cols"=>"50","rows"=>"5"));
    $form->addInput(array("type"=>"textarea","name"=>"custcoo","cols"=>"50","rows"=>"5"));
    $form->addInput(array("type"=>"textarea","name"=>"comment","cols"=>"50","rows"=>"5"));
    $form->addInput(array("type"=>"floatfield","name"=>"tax","size"=>"10","format"=>".2"));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit"));
	
	$bean = new ActionForm("invoiceBean", $form, $request);
	$form->setValueByElement("btsubmit",$i18n->getKey('button.generate'));
	
	if ($request->getMethod()=="POST") {

		$d = new DateTime($i18n->getDateFormat(),$bean->getAttribute("date"));
		$validator = new Validator($bean->getAttribute("date"));
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		if (!$validator->isValid() || $d->isError()) {
			$errors->add("date",$i18n->getKey("errors.wrong"),$i18n->getKey("form.invoice.date"));	
		}
		
		$validator = new Validator($bean->getAttribute("number"));
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		//$validator->validateLatinCharset();
		if (!$validator->isValid()) {
			$errors->add("number",$i18n->getKey("errors.wrong"),$i18n->getKey("form.invoice.number"));	
		}
		
		if ($bean->getAttribute("tax")) {
			$validator = new Validator($bean->getAttribute("tax"));
			$validator->validateSpaceString();
			$validator->validateEmptyString();
			$validator->validateFloat($i18n->getFloatDelimiter());
			if (!$validator->isValid()) {
				$errors->add("tax",$i18n->getKey("errors.wrong"),$i18n->getKey("form.invoice.tax"));	
			}
		}
		
        if ($errors->isEmpty()) {
        	$bean->saveBean();
        	
        	InvoiceHelper::saveInvoiceHeader($user, $bean);
        	header("Location: invoice_table.php");
        }
	}
	
	if (!$bean->isSaved()) { // stored in session
		InvoiceHelper::loadInvoiceHeader($user, $bean);
    	
		$crdate = new DateTime($i18n->getDateFormat());
		$form->setValueByElement("date", $crdate->toString());
    }
	
    if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
    $smarty->assign("forms",array($form->getName()=>$form->toArray()));
    $smarty->assign("onload","onLoad = \"document.invoiceForm.number.focus()\"");
	$smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
	$smarty->assign("title_page",$i18n->getKey("form.invoice.title"));
  	$smarty->assign("content_page_name", "invoice.tpl");
  	$smarty->display(INDEX_TEMPLATE);
?>