<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+
// | Contributors: Sergey Kikot <skikot@wrconsulting.com>
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('UserHelper');
	import('ProjectHelper');

	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}
	
	$cl_project_id = (int)$request->getParameter('pr_id');
	if ($cl_project_id>0) {
		$_SESSION["cl_project_id"] = $cl_project_id;
	}
	if ($cl_project_id==0) {
		$cl_project_id = $_SESSION["cl_project_id"];
	}
	
	$ud = ProjectHelper::findProjectById($user->getUserId(), $cl_project_id);
	if ($request->getMethod()=="POST") {
		$cl_name  = $request->getParameter('name');
		$cl_name  = trim($cl_name);
	} else {
        $cl_name	= $ud["p_name"];
	}
	
	$form = new Form('projectForm');
	$form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"name","value"=>$cl_name));
    $form->addInput(array("type"=>"hidden","name"=>"pr_id","value"=>$cl_project_id));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit","value"=>$i18n->getKey('button.save')));
	
	if ($request->getMethod()=="POST") {
		import('form.check.Validator');
		
		$validator = new Validator($cl_name);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		if (!$validator->isValid()) {
			$errors->add("name",$i18n->getKey("errors.wrong"),$i18n->getKey("form.project.name"));	
		}
		
		if ($errors->isEmpty()) {
			$ulo = ProjectHelper::findProjectByName($user->getUserId(), $cl_name);
			if (($ulo && $cl_project_id==$ulo["p_id"]) || (!$ulo)) {
				if (ProjectHelper::update($user->getUserId(), $cl_project_id, $cl_name)) {
					Header("Location: projects.php");
					exit();
				} else
					$errors->add("editproj",$i18n->getKey("errors.project_update"));
			} else 
				$errors->add("editproj",$i18n->getKey("errors.project_exist"));
		}			
	} // post
	
	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
    $smarty->assign("forms",array($form->getName()=>$form->toArray()));
    $smarty->assign("onload","onLoad=\"document.projectForm.name.focus()\"");
    $smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("title_page",$i18n->getKey("form.project.edit_str"));
    if ($ud) {
    	$smarty->assign("content_page_name","project_edit.tpl");
    } else {
    	$smarty->assign("content_page_name","syserror.tpl");
    }
  	$smarty->display(INDEX_TEMPLATE);
?>